<?php
// Copyright (c) 2010, PRiSE. All Rights Reserved.
// Based on the icGPoA developed by RedIRIS.
//
// You may distribute under the terms of the GNU General Public License,
// as specified in the LICENSE file that was shipped with this distribution

require_once("config.php");
require_once("util.php");
require_once("backend.php");

function papi_icgpoa_core() {
    global $ICGPOA_KEY_SIZE, $ICGPOA_TTL, $ICGPOA_ACCEPTED_POAS, $ICGPOA_AS_ID, $ICGPOA_PRIVATE_KEY;
    //
    // Comprobaciones sobre la peticion PAPIv1
    //
    if (!isset($_REQUEST["ACTION"]) && !isset($_REQUEST["ATTREQ"])) {
        error("Unknown request. Use the PAPI 1.0 protocol");
    }
    if (isset($_REQUEST["ACTION"]) && ($_REQUEST["ACTION"] != "CHECK" || !isset($_REQUEST["DATA"]) || !isset($_REQUEST["URL"]))) {
        error("Unknown request. Use the PAPI 1.0 protocol");
    }
    if (isset($_REQUEST["ATTREQ"]) && (!isset($_REQUEST["PAPIPOAREF"]) || !isset($_REQUEST["PAPIPOAURL"]))) {
        error("Unknown request. Use the PAPI 1.0 protocol");
    }
    if (isset($_REQUEST["ACTION"])) {
        $theURL = $_REQUEST["URL"];
        $theRef = $_REQUEST["DATA"];
    }
    else {
        $theURL = $_REQUEST["PAPIPOAURL"];
        $theRef = $_REQUEST["PAPIPOAREF"];
    }
    //
    // Comprobaciones sobre los dominios permitidos a enviarle una peticion PAPIv1
    //
    $valid = false;
    foreach ($ICGPOA_ACCEPTED_POAS as $poa) {
        $valid |= preg_match("/".$poa."/", $theURL);
    }
    if ($valid == false) {
        error("No matching PoA found");
    }
    //
    // Obtiene la URL del PoA que inició la cadena de mensajes PAPI
    //
    $papiopoa = $theURL;
    if (isset($_REQUEST["PAPIOPOA"])) {
        $papiopoa = $_REQUEST["PAPIOPOA"];
    }
    //
    // Genera la aserción del usuario y la encripta con la clave privada
    //
    $userid = papi_icgpoa_username();
    $list_attrs = papi_icgpoa_attrlist($userid, $papiopoa);
    $attrs = array();
    foreach ($list_attrs as $nameattr => $values) {
        $parsedvalues = implode("|", $values);
        $attrs[] = $nameattr."=".$parsedvalues;
    }
    $attributes = implode(",",$attrs);
    $assertion = $attributes."@".$ICGPOA_AS_ID;
    $now = time();
    $ext = $now + $ICGPOA_TTL;
    $reply = $assertion . ":" . $ext . ":" . $now . ":" . $theRef;
    $safe = encrypt_private_key($reply, $ICGPOA_PRIVATE_KEY, $ICGPOA_KEY_SIZE);
    //
    // Construye mensaje de respuesta conforme a protocolo PAPIv1
    //
    if (strpos($theURL, "?")) {
        $redirectTo = $theURL . "&";
    } else {
        $redirectTo = $theURL . "?";
    }
    if (isset($_REQUEST["ACTION"])) {
        $redirectTo .= "ACTION=CHECKED" . "&" . "DATA=" . urlencode($safe);
        doLog("GPoA response to " . $theURL . ": " . $reply);
    }
    else {
        $redirectTo .= "AS=" . $ICGPOA_AS_ID . "&ACTION=CHECKED" . "&" . "DATA=" . urlencode($safe);
        doLog("AS response to " . $theURL . ": " . $reply);
    }
    header("Location: $redirectTo");
}
?>